/*
 * SonarSource Language Recognizer
 * Copyright (C) 2010 SonarSource
 * dev@sonar.codehaus.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package com.sonar.sslr.api;

/**
 * The AstVisitor allows to visit some desired AstNode. The AstAndTokenVisitor extends this first interface to add a new feature : being
 * visited for each Token generated by the Lexer.
 * 
 */
public interface AstAndTokenVisitor extends AstVisitor {

  /**
   * Called sequentially for each token generated by the Lexer
   * 
   * @param token
   *          Token to visit
   */
  void visitToken(Token token);
}
